package com.weaver.seconddev.cockpit.cmd;

import com.weaver.ebuilder.datasource.api.entity.SqlParamEntity;
import com.weaver.ebuilder.datasource.api.enums.SqlParamType;
import com.weaver.seconddev.cockpit.util.DatabaseUtils;
import com.weaver.seconddev.cockpit.util.JucailinCockpitUtils;
import com.weaver.teams.domain.user.SimpleEmployee;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import java.util.*;

/**
 * 流程、日程、协助、文档 4个类型数据
 *
 * @author shil
 * @version 1.00版本
 * @Date 2024/5/22
 */
@Component
public class CockpitUserDataCmd {
    //日志
    private final static Logger log = LoggerFactory.getLogger(CockpitUserDataCmd.class);

    @Autowired
    private JucailinCockpitUtils jucailinCockpitUtils;

    @Autowired
    private DatabaseUtils databaseUtils;


    public Map<String, Object> getDataInfo(SimpleEmployee employee, Map<String, Object> paramMap,String tenantKey) {

        Map<String, Object> recordMap = new HashMap<String, Object>();
        String sourceType = "LOGIC";
        try {
            String employeeId = String.valueOf(employee.getEmployeeId());

            String username = employee.getName();
            String deptnme = employee.getDepartment().getName();
            String subcompanynme = employee.getDepartment().getParent().getName();

            String positionname = employee.getPosition().getName();
            String gradename = employee.getGrade().getName();

            String personnelstatusname = "" ;
            String personnelstatus = employee.getPersonnelStatus();
            if("1".equals(personnelstatus)){
                personnelstatusname = "试用员工";
            }else if("2".equals(personnelstatus)){
                personnelstatusname = "试用延期员工";
            }else if("3".equals(personnelstatus)){
                personnelstatusname = "正式员工";
            }else if("4".equals(personnelstatus)){
                personnelstatusname = "临时员工";
            }else if("5".equals(personnelstatus)){
                personnelstatusname = "实习员工";
            }else if("6".equals(personnelstatus)){
                personnelstatusname = "离职员工";
            }else if("7".equals(personnelstatus)){
                personnelstatusname = "退休员工";
            }else if("9".equals(personnelstatus)){
                personnelstatusname = "解聘员工";
            }else if("10".equals(personnelstatus)){
                personnelstatusname = "无效员工";
            }

            String userimageurl = "/profile/" + employeeId + "/personal";

            long formdata = employee.getFormdata();
            String pkey = "field69.groupId";
            String groupId =  jucailinCockpitUtils.getUfPropData(pkey,tenantKey);
            log.error("groupId:"+groupId);

            String jobcallname = "";
            long jobcallid = employee.getJobCall();
            if(StringUtils.isNotBlank(jobcallid+"")){
                String sql =" select data_name from hrm_jobcall " +
                            " where id = ? "+
                            " and delete_type = 0\n" +
                            " and tenant_key = ? \n" ;

                List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
                SqlParamEntity sqlParamEntity = new SqlParamEntity();
                sqlParamEntity.setParamType(SqlParamType.LONG);
                sqlParamEntity.setValue(employeeId+"");
                sqlparam.add(sqlParamEntity);

                sqlParamEntity = new SqlParamEntity();
                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
                sqlParamEntity.setValue(tenantKey);
                sqlparam.add(sqlParamEntity);

                Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
                if(!recordList.isEmpty() && recordList.size()>0){
                    jobcallname = String.valueOf(recordList.get(0).get("data_name"));
                }
            }

            String field69 = "";
            if(StringUtils.isNotBlank(formdata+"s")){
                String sql =" select field69 from eteams.Hrmemployeedefined where form_data_id = ?" ;
                log.error("getSelfServiceData--sql:"+sql);

                List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
                SqlParamEntity sqlParamEntity = new SqlParamEntity();
                sqlParamEntity.setParamType(SqlParamType.LONG);
                sqlParamEntity.setValue(formdata+"");
                sqlparam.add(sqlParamEntity);
                Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
                if(recordList.size()>0){
                    field69 = String.valueOf(recordList.get(0).get("field69"));
                }

                if("1".equals(field69)){
                    field69 = "销售";
                }else if("2".equals(field69)){
                    field69 = "项目";
                }else if("3".equals(field69)){
                    field69 = "技术";
                }else if("4".equals(field69)){
                    field69 = "客服";
                }else if("5".equals(field69)){
                    field69 = "运营";
                }
            }

            recordMap.put("employeeId",employeeId);
            recordMap.put("username",username);
            recordMap.put("deptmentnnme",subcompanynme+"-"+deptnme);
            recordMap.put("positionname",positionname);
            recordMap.put("userimageurl",userimageurl);
            recordMap.put("jobcallname",jobcallname);
            recordMap.put("personnelstatusname",personnelstatusname);
            recordMap.put("personnelstatus",personnelstatus);
            recordMap.put("gradename",gradename);
            recordMap.put("field69",field69);

        } catch (Exception e) {
            e.printStackTrace();
            log.error("PortalPerformanceInfoCmd :" + e);
        }
        return recordMap;
    }
}
